#include <cstdlib>
#include <iostream>

/*
#include "parport.h"
#include "piccmd.h"
#include "ihex.h"
*/

#include "program.h"


using namespace std;

void usage( char *exename )
{
  char *name;
  
  name = exename;
  for ( uint16_t i = 0; i < strlen(exename); i++ )
  {
    if ( exename[i] == '\\' )
    {
      name = &exename[ i+1 ];
    }
  }
  
  printf( "usage: %s [options] [filename]\n", name );
  printf( "options:\n \
  \t -e = erase\n \
  \t -w = write\n \
  \t -v = verify\n \
  \t -r = read\n \
  \t -s = stop (reset)\n \
  \t -g = go (not reset)\n \
  \t -p = pause\n \
  \t -d = debug\n \
  \t -m = verbose\n \
  \n\n" );
  system( "PAUSE" );
}

int main(int argc, char *argv[])
{
  printf( "LVP toasting software for PIC16F819 @ TLVP\n" );
  printf( "TLVP -> http://www.finitesite.com/d3jsys/\n" );
  printf( "this software is written by Matthias Fischer\n" );
  printf( "\n" );
  
  std::string filename = "";
  uint8_t w,r,v,s,g,p,d,e,m;
  w=r=v=s=g=p=d=e=m = 0;
  
  for ( uint8_t i = 1; i < argc; i++ )
  {
    if ( argv[i][0] == '-' )
    {
      // option
      for ( uint8_t x = 1; x < strlen(argv[i]); x++ )
      {
        switch( argv[i][x] )
        {
          /*
          case '': =1; break;
          */
          case 'w': w=1; break;
          case 'r': r=1; break;
          case 'v': v=1; break;
          case 's': s=1; break;
          case 'g': g=1; break;
          case 'p': p=1; break;
          case 'd': d++; break;
          case 'm': m++; break;
          case 'e': e=1; break;
        }
      }
    }
    else
    {
      // filename
      filename = argv[i];
    }
  }
  
  if ( w==0 && r==0 && v==0 && s==0 && g==0 && p==0 && d==0 && e==0 && m==0 )
  {
    usage( argv[0] );
  }
  
  //printf( "filename >%s<\n", filename.c_str() );
  
  class program program;
  
  program.verbose( m );
  
  if ( d )
    program.debugmode( d );
  
  program.setfilename( filename );
  
  if ( e )
    program.erase();
  
  if ( w )
    program.write();
  
  if ( v )
    program.verify();
  
  if ( r )
    program.read();
  
  if ( s )
    program.stop();
  
  if ( g )
    program.go();
  
  printf("\n");
  if ( p )
    system("PAUSE");
  
  return EXIT_SUCCESS;
}
